PlayerCc::Position1dProxy Class Reference
Proxies

The `Position1dProxy` class is used to control a position1d device. More...

`#include <playerc++.h>`

Inheritance diagram for PlayerCc::Position1dProxy:

## Public Member Functions

| Position1dProxy (PlayerClient *aPc, uint32_t aIndex=0)
| constructor
| ~Position1dProxy ()
| destructor
void | SetSpeed (double aVel)
| Send a motor command for velocity control mode. More...
void | GoTo (double aPos, double aVel)
| Send a motor command for position control mode. More...
void | RequestGeom ()
| Get the device's geometry; it is read into the relevant class attributes. More...
player_pose3d_t | GetPose () const
| Accessor for the pose (fill it in by calling RequestGeom)
player_bbox3d_t | GetSize () const
| Accessor for the size (fill it in by calling RequestGeom)
void | SetMotorEnable (bool enable)
| Enable/disable the motors. More...
void | SetOdometry (double aPos)
| Sets the odometry to the pose `aPos`. More...
void | ResetOdometry ()
| Reset odometry to 0.
double | GetPos () const
| Set PID terms. More...
double | GetVel () const
| Accessor method.
bool | GetStall () const
| Accessor method.
uint8_t | GetStatus () const
| Accessor method.
bool | IsLimitMin () const
| Accessor method.
bool | IsLimitCen () const
| Accessor method.
bool | IsLimitMax () const
| Accessor method.
bool | IsOverCurrent () const
| Accessor method.
bool | IsTrajComplete () const
| Accessor method.
bool | IsEnabled () const
| Accessor method.
Public Member Functions inherited from PlayerCc::ClientProxy
bool | IsValid () const
| Returns true if we have received any data from the device.
bool | IsFresh () const
| Fresh is set to true on each new read. More...
void | NotFresh ()
| This states that the data in a client is currently not Fresh.
std::string | GetDriverName () const
| Returns the driver name. More...
double | GetDataTime () const
| Returns the received timestamp [s].
double | GetElapsedTime () const
| Returns the received timestamp [s].
PlayerClient * | GetPlayerClient () const
| Returns a pointer to the Player Client.
uint32_t | GetIndex () const
| Returns device index.
uint32_t | GetInterface () const
| Returns device interface.
std::string | GetInterfaceStr () const
| Returns device interface.
void | SetReplaceRule (bool aReplace, int aType=-1, int aSubtype=-1)
| Set a replace rule for this proxy on the server. More...
int | HasCapability (uint32_t aType, uint32_t aSubtype)
| Request capabilities of device. More...
int | GetBoolProp (char *aProperty, bool *aValue)
| Request a boolean property.
int | SetBoolProp (char *aProperty, bool aValue)
| Set a boolean property.
int | GetIntProp (char *aProperty, int32_t *aValue)
| Request an integer property.
int | SetIntProp (char *aProperty, int32_t aValue)
| Set an integer property.
int | GetDblProp (char *aProperty, double *aValue)
| Request a double property.
int | SetDblProp (char *aProperty, double aValue)
| Set a double property.
int | GetStrProp (char *aProperty, char **aValue)
| Request a string property.
int | SetStrProp (char *aProperty, char *aValue)
| Set a string property.
template<typename T >
connection_t | ConnectReadSignal (T aSubscriber)
| Connect a signal to this proxy For more information check out Signals & multithreading.
void | DisconnectReadSignal (connection_t aSubscriber)
| Disconnect a signal to this proxy.

## Private Member Functions

void | Subscribe (uint32_t aIndex)
void | Unsubscribe ()

## Private Attributes

playerc_position1d_t * | mDevice

## Additional Inherited Members

Public Types inherited from PlayerCc::ClientProxy
typedef int | connection_t
typedef boost::mutex::scoped_lock | scoped_lock_t
typedef int | read_signal_t
Protected Member Functions inherited from PlayerCc::ClientProxy
| ClientProxy (PlayerClient *aPc, uint32_t aIndex)
template<typename T >
T | GetVar (const T &aV) const
template<typename T >
void | GetVarByRef (const T aBegin, const T aEnd, T aDest) const
Protected Attributes inherited from PlayerCc::ClientProxy
PlayerClient * | mPc
playerc_client_t * | mClient
playerc_device_t * | mInfo
bool | mFresh

## Detailed Description

The `Position1dProxy` class is used to control a position1d device.

The latest position data is contained in the attributes pos, vel , etc.

## Member Function Documentation

double PlayerCc::Position1dProxy::GetPos | ( |  | ) | const

inline

Set PID terms.

Set PID terms Set speed ramping profile spd rad/s, acc rad/s/s Accessor method

void PlayerCc::Position1dProxy::GoTo | ( | double | aPos,
|  | double | aVel
| ) |  |

Send a motor command for position control mode.

Specify the desired pose of the robot in [m] or [rad] desired motion in [m/s] or [rad/s]

void PlayerCc::Position1dProxy::RequestGeom | ( |  | ) |

Get the device's geometry; it is read into the relevant class attributes.

void PlayerCc::Position1dProxy::SetMotorEnable | ( | bool | enable | ) |

Enable/disable the motors.

Set `state` to 0 to disable or 1 to enable. Be VERY careful with this method! Your robot is likely to run across the room with the charger still attached.

void PlayerCc::Position1dProxy::SetOdometry | ( | double | aPos | ) |

Sets the odometry to the pose `aPos`.

Note
  aPos is in either [m] or [rad] depending on the actuator type

void PlayerCc::Position1dProxy::SetSpeed | ( | double | aVel | ) |

Send a motor command for velocity control mode.

Specify the forward, sideways, and angular speeds in m/sec, m/sec, and radians/sec, respectively.

The documentation for this class was generated from the following file:

- playerc++.h

Last updated 12 September 2005 21:38:45